//Payday Health Script 1.0 by Fierelier
//Donate: https://www.paypal.me/Fierelier/

using System;
using System.Windows.Forms;
using GTA;

namespace pdHealth
{
	public class pdHealth : Script
	{

		public pdHealth()
		{
			this.Tick += new EventHandler(this.doHealthTick);
		}
		
		//SETTINGS
		//Script
		int tickTime = 100;			//Tick-Rate in ms.
		
		//Regeneration
		int armorRegen = 25;		//How far to regenerate the armor. Set to 0 to disable regenaration entirely.
		int armorRegenSpeed = 1;	//How much armor to regenerate per tick.
		int armorRegenDelay = 5000;	//Delay after damage before recharging armor. Set to 0 to disable delay.
		
		//Max Armor/Health
		int overrideHealth = 50;	//Set your max health to balance the regenerating armor. Values over 100 don't do anything (unless max health is altered by a trainer). Set to -1 to use default health.
		int overrideArmor = -1;		//Set your max armor. Basically the same as above.
		
		//Other armor options
		bool allDamageArmor = true;	//The armor soaks up all the damage, even fall and explosion-damage.
		float armorDefense = 1.0F;	//How much damage should the armor soak up while active? Set to 1.0 (default) to make it soak up all damage, set to 0.5 to make it soak up half damage, etc.
		
		//VARIABLES (DO NOT TOUCH)
		int armorVal = -1;
		int healthVal = -1;
		int timeUntilRegen = 0;
		
		private void doHealthTick(object sender, EventArgs e)
		{
			Ped pl = Player.Character;
			
			if (overrideHealth != -1) {
				//if (pl.Health > overrideHealth) { Player.MaxHealth = overrideHealth; pl.Health = overrideHealth; }
				if (pl.Health > overrideHealth) { pl.Health = overrideHealth; }
			}
			
			if (overrideArmor != -1) {
				//if (pl.Armor > overrideArmor) { Player.MaxArmor = overrideArmor; pl.Armor = overrideArmor; }
				if (pl.Armor > overrideArmor) { pl.Armor = overrideArmor; }
			}
			
			if (pl.isAlive == false) {
				armorVal = -1;
				healthVal = -1;
				timeUntilRegen = 0;
				Wait(tickTime);
				return;
			}
			
			if (allDamageArmor == true) {
				if (pl.Health < healthVal) {
					int damageTaken = healthVal - pl.Health;
					if (damageTaken < pl.Armor) {
						pl.Health = pl.Health + damageTaken;
						pl.Armor = pl.Armor - damageTaken;
					} else {
						pl.Health = pl.Health + pl.Armor;
						pl.Armor = 0;
					}
				}
			}
			
			if (pl.Armor < armorVal) {
				if (armorDefense < 1.0F) {
					pl.Health = (int)Math.Round(pl.Health - ((armorVal - pl.Armor)*1.0f-armorDefense));
				}
			}
			
			if (armorRegen > 0) {
				if (pl.Armor < armorVal) { timeUntilRegen = armorRegenDelay; }
				if (pl.Health < healthVal) { timeUntilRegen = armorRegenDelay; }
				
				if (timeUntilRegen > 0) {
					timeUntilRegen = timeUntilRegen - tickTime;
					if (timeUntilRegen < 0) { timeUntilRegen = 0; }
				} else {
					if (pl.Armor < armorRegen) {
						pl.Armor = pl.Armor + armorRegenSpeed;
						if (pl.Armor > armorRegen) { pl.Armor = armorRegen; }
					}
				}
			}
			
			armorVal = pl.Armor;
			healthVal = pl.Health;
			Wait(tickTime);
		}
	}
}